#include "..\TestHarness\TestHarness.h"


//You should organize your tests so that there is one test file for each class
//The TestGroup should match the class name being tested

TEST(TestGroup, AllTheseTestsPass)
{
  //Check any boolean condition
  CHECK(0 == 1);

  // Check two things with for equality using ==
  //
  // In this example these strings are equal because the address of the 
  // char*'s are the same.
  //
  // you can expand the usefulness of CHECK_EQUAL macro if 
  // you feed it objects that have operator=() and a StringFrom 
  // function defined (see SimpleString.h).
  // For example you could compare std::string with CHECK_EQUAL if 
  // you define the StringFrom(sdt::string&) method
  CHECK_EQUAL("string one", "string one");

  //check if two longs are equal
  LONGS_EQUAL(100, 100)

  //check that two char*'s contents are the same
  STRCMP_EQUAL("HELLO", "HELLO");

  //Check that two doubles are equal within some tolerance
  DOUBLES_EQUAL(1.25, 1.26, .05);
}

TEST(TestGroup, Fail)
{
  FAIL("Because I said so");
}



TEST(TestGroup, AllThesePassButTheFAIL)
{
  //Check any boolean condition
  CHECK(0 == 1);

  FAIL("This is not executed");

}


TEST(TestGroup, CheckEqualError)
{
  // In this example these strings are not equal because the 
  // address of the char*'s are the different.
  CHECK_EQUAL("string one", "string two");

  FAIL("This is not executed");

}


TEST(TestGroup, LongsEqualFails)
{

  LONGS_EQUAL(100, -100)

  FAIL("This is not executed");
}

TEST(TestGroup, CmpStrEqualError)
{
  STRCMP_EQUAL("HELLO", "GOODBYE");

  FAIL("This is not executed");
}

TEST(TestGroup, DoubleEqualError)
{

  DOUBLES_EQUAL(1.25, 1.26, .00);

  FAIL("This is not executed");
}

