
#include "TestResult.h"
#include "Failure.h"

#include <stdio.h>


TestResult::TestResult ()
	: testCount(0)
  , checkCount(0)
  , failureCount (0)
{
}


void TestResult::testsStarted () 
{
}


void TestResult::addFailure (const Failure& failure) 
{
	fprintf (stdout, "\n%s%s%s\n\t%s%ld%s%s\n",
		"Failure: \"",
		failure.message.asCharString (),
		"\" " ,
		"line ",
		failure.lineNumber,
		" in ",
		failure.fileName.asCharString ());
		
	failureCount++;
}

void TestResult::countTest()
{
  testCount++;
}

void TestResult::countCheck()
{
  checkCount++;
}

void TestResult::testsEnded () 
{
	fprintf (stdout, "\n%ld tests ran with %ld checks executed and ", testCount, checkCount);

  if (failureCount > 0)
		fprintf (stdout, "%ld failures\n", failureCount);
	else
		fprintf (stdout, "no test failures\n");
}
