
// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	

#include <Platform.h>
#include "ColumnFixture.h"

#include "Parse.h"
#include "TypeAdapter.h"



ColumnFixture::~ColumnFixture()
{
}

const Fixture	*ColumnFixture::getTargetClass() const
{
	return this;
}


void ColumnFixture::doRows(ParsePtr rows)
{	
	bind(rows->parts);
	Fixture::doRows(rows->more);
}


void ColumnFixture::doCell(ParsePtr cell, int column)
{
    TypeAdapter *a = columnBindings[column];
    try {
        if (a == 0) {
            ignore(cell);
        } else if (a->isObject()) {
            string text = cell->text();
            if (text != "") {
                a->set(text);
            }
        } else if (!a->isObject()) {
            check(cell, a);
        }
    } catch(exception& e) {
        handleException(cell, e);
    }

}


void ColumnFixture::bind (ParsePtr heads) 
{
    for (int i=0; heads; i++, heads = heads->more) {
		columnBindings.push_back(0);
        string name = heads->text();
        string suffix = "()";
		try {
			if (endsWith(name, suffix)) {
				string methodName = name.substr(0,name.size() - suffix.size());
				columnBindings[i] = getTargetClass()->adapterFor(methodName);
			}
			else {
				columnBindings[i] = getTargetClass()->adapterFor(name);
			}
		}
        catch (exception& e) {
            handleException (heads, e);
        }
    }
}

