

// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	

#ifndef COMMANDADAPTER_H
#define COMMANDADAPTER_H

#include "TypeAdapter.h"
#include "IllegalAccessException.h"

#define PUBLISH_COMMAND(testClass,name)\
		adapters.push_back(new CommandAdapter<testClass>(#name, &testClass::name, this));

#include <strstream>
#include <string>

using namespace std;


template<typename AFixture>
class CommandAdapter : public TypeAdapter
{
	typedef void (AFixture::*Command)();

public:
	CommandAdapter(const string& name, Command command, AFixture *fixture) 
		: TypeAdapter(name), command(command), fixture(fixture)
	{
	}


	virtual void set(const string& newValue)
	{
	}

	virtual void invoke(const vector<string>& args = noArgs)
	{
		if(args.size() != 0)
			throw IllegalAccessException("Expected zero arguments in CommandAdapter");
		(fixture->*command)();
	}

	virtual string valueAsString()
	{
		return "";
	}

	virtual bool isObject() const
	{
		return false;
	}

private:
	Command				command;
	AFixture			*fixture;

};




#endif
