
// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	

#ifndef PARSEEXCEPTION_H
#define PARSEEXCEPTION_H

#include <strstream>

using namespace std;

class ParseException : public exception
{
public:
	ParseException(const string& text, int offset) 
		: message(text), offset(offset)
	{
	}

	virtual const char *what() const throw() 
	{
		return message.c_str();
	}

	virtual int getErrorOffset() const
	{
		return offset;
	}

private:
	string message;
	int	   offset;
};

#endif