
// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	

#ifndef TYPEADAPTER_H
#define TYPEADAPTER_H

#include <string>
#include <vector>

class Fixture;

using namespace std;


class TypeAdapter
{
public:
								TypeAdapter(const string& name);

	virtual void				set(const string& newValue) = 0;
	virtual const string		getName() const;
	virtual void				invoke(const vector<string>& args = noArgs) = 0;
	virtual string				valueAsString() = 0;
	virtual bool				isObject() const = 0;

	static TypeAdapter			*on(Fixture *f, const string& member);

	string						name;
	static const vector<string>	noArgs;

private:
								TypeAdapter(const TypeAdapter&);
	TypeAdapter&				operator=(TypeAdapter&);


};


#endif