
// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	

#include <Platform.h>

#include <Parse.h>
#include <Fixture.h>

#include "DynamicMaker.h"

string stringOf(string fileName) 
{
	string content;

	FILE *fp = fopen(fileName.c_str(), "r");

	if (fp) {
		int c;
		while (EOF != (c = fgetc(fp)))
			content += c;
		fclose(fp);
	}
	return content;
}


int main(int ac, char **av) 
{

	if (ac != 2) {
		fprintf(stderr,"Usage: fit <input-HTML-file>\n\n");
		exit(0);
	}

	try {
		Parse p(stringOf(av[1]));

		Fixture fixture;
		DynamicMaker maker;

		fixture.setMaker(&maker);
		fixture.doTables(&p);

		string out;
		p.print(out);

		fprintf(stdout,"%s",out.c_str());
	} catch(exception& e) {
		fprintf(stderr,"Unexpected exception: %s\n", e.what());
	}


	return 0;
}


