
// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	


#include <Platform.h>

#include "AddEmployees.h"
#include "PayrollTestServer.h"
#include "../PayrollLib/AddEmployeeTransaction.h"


AddEmployees::AddEmployees()
{
	PUBLISH(AddEmployees,string,name);
	PUBLISH(AddEmployees,int,employeeID);
	PUBLISH(AddEmployees,double,hourlyRate);
}


void AddEmployees::doRow(ParsePtr row) 
{
	ColumnFixture::doRow(row);
	addEmployee();
}


void AddEmployees::addEmployee()
{
	int rateInCents = hourlyRate * 100;
	AddEmployeeTransaction transaction(
								PayrollTestServer::db, name, employeeID, rateInCents);

	transaction.run();
}
