

// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	


#include <Platform.h>

#include "OutputCommands.h"
#include "PayrollTestServer.h"
#include "../PayrollLib/PaydayTransaction.h"
#include "../PayrollLib/StringTokenizer.h"



RowFixture::ObjectList OutputCommands::query() const
{
	target.clear();
	PaydayTransaction transaction(PayrollTestServer::db, &target);

	transaction.run();

	return target.lastRows;
}


void OutputCommands::CommandTarget::write(const string& out)
{
	StringTokenizer tokenizer(out);
	lastRows.push_back(new EmployeeCheck(
			tokenizer.getInteger(1), 
			tokenizer.getCurrencyAmount(3)));

}

void OutputCommands::CommandTarget::clear()
{
	lastRows.clear();
}


const Fixture *OutputCommands::getTargetClass() const
{
	return &exampleCheck;
}

