
// Copyright (c) 2003 Michael Feathers
// Based on FIT by Cunningham & Cunningham, Inc
// Released under the terms of the GNU General Public License version 2 or later.	

#ifndef OUTPUTCOMMANDS_H
#define OUTPUTCOMMANDS_H


#include <RowFixture.h>
#include "../PayrollLib/Output.h"


class OutputCommands : public RowFixture
{
public:
	class EmployeeCheck : public Fixture
	{
	public:
					EmployeeCheck()
						: id(0), payment(0) 
					{ initialize(); }

					EmployeeCheck(int id, int cents)
						: id(id), payment(cents / 100) 
					{ initialize(); }

		void		initialize()
					{
						PUBLISH(EmployeeCheck,int,id);
						PUBLISH(EmployeeCheck,double,payment);
					}

		int id;
		double payment;


	};

	class CommandTarget : public Output
	{
	public:
		virtual void					write(const string& out);
		void							clear();
		mutable RowFixture::ObjectList	lastRows;
	};


	virtual RowFixture::ObjectList		query() const;
	virtual const Fixture				*getTargetClass() const;

	mutable CommandTarget				target;
	EmployeeCheck						exampleCheck;

};

#endif


