

#ifndef STRINGTOKENIZER_H
#define STRINGTOKENIZER_H


#include <string>
#include <vector>

class StringTokenizer
{
public:
	StringTokenizer(const std::string& source);
	int tokenCount() const;

	int getInteger(int tokenNumber) const;
	std::string getString(int tokenNumber) const;
	int getCurrencyAmount(int tokenNumber) const;

	std::vector<std::string>& getTokens()
	{ return tokens; }

	static std::string	trim(const std::string& field);

private:
	bool		inRange(int tokenNumber) const;
	void		appendToken(const std::string& token);

	std::string source;
	std::vector<std::string> tokens;
};

#endif