#pragma warning(disable:4786)


#include <TestHarness/TestHarness.h>
#include "StringTokenizer.h"


TEST(StringTokenizer,empty)
{
	StringTokenizer tokenizer("");

	LONGS_EQUAL(0, tokenizer.tokenCount())
}


TEST(StringTokenizer,one)
{
	StringTokenizer tokenizer("ab");

	LONGS_EQUAL(1, tokenizer.tokenCount())
}



TEST(StringTokenizer,two)
{
	StringTokenizer tokenizer("ab,ca");

	LONGS_EQUAL(2, tokenizer.tokenCount())
	CHECK("ab" == tokenizer.getTokens()[0]);
	CHECK("ca" == tokenizer.getTokens()[1]);
}


TEST(StringTokenizer,asTypes)
{
	StringTokenizer tokenizer("1,ca,$50");

	LONGS_EQUAL(1, tokenizer.getInteger(0))
	CHECK("ca" == tokenizer.getString(1));
	LONGS_EQUAL(5000,tokenizer.getCurrencyAmount(2));
}



TEST(StringTokenizer,whitespaceInvariant)
{
	StringTokenizer tokenizer("a, b, c");
	CHECK("a" == tokenizer.getString(0));
	CHECK("b" == tokenizer.getString(1));

}


TEST(StringTokenizer,trim)
{

	CHECK("a" == StringTokenizer::trim(" a"));
	CHECK("b" == StringTokenizer::trim("b "));
	CHECK("" == StringTokenizer::trim(""));
	CHECK("asd" == StringTokenizer::trim(" asd "));
}
