

#include "..\TestHarness\TestHarness.h"

#include "TransactionSource.h"
#include "Transaction.h"
#include "PaydayTransaction.h"
#include "TimeCardTransaction.h"
#include "AddEmployeeTransaction.h"


TEST(TransactionSource,getTransaction)
{
	TransactionSource source;

	Transaction *transaction = source.getNextTransaction();
	CHECK(dynamic_cast<Transaction *>(transaction));
	delete transaction;
}



TEST(TransactionSource,getPaydayTransaction)
{
	TransactionSource source ("Payday");

	Transaction *transaction = source.getNextTransaction();
	CHECK(dynamic_cast<PaydayTransaction *>(transaction));
	delete transaction;
}


TEST(TransactionSource,getTimeCardTransaction)
{
	TransactionSource source ("TimeCard");

	Transaction *transaction = source.getNextTransaction();
	CHECK(dynamic_cast<TimeCardTransaction *>(transaction));
	delete transaction;
}


TEST(TransactionSource,getAddEmployeeTransaction)
{
	TransactionSource source ("AddEmployee");

	Transaction *transaction = source.getNextTransaction();
	CHECK(dynamic_cast<AddEmployeeTransaction *>(transaction));
	delete transaction;
}
